#include "stdafx.h"

#include "wizard_finished_page.h"
#include "grt/common.h"

using namespace grtui;

WizardFinishedPage::WizardFinishedPage(WizardForm *form, const std::string &top_title)
  : WizardPage(form, "finish")
{
  set_short_title(_("Results"));
  
  _label1.set_style(mforms::BoldStyle);

  set_spacing(12);
  set_padding(24);
  
  _top_title= top_title;
  _label2.set_text_align(mforms::TopLeft);
  _label2.set_wrap_text(true);
  
  _label1.set_text("");
  _label2.set_text("");

  add(&_label1, false, false);
  add(&_label2, false, true);
}



void WizardFinishedPage::set_heading(const std::string &title)
{
  _label1.set_text(title);
}


void WizardFinishedPage::set_summary(const std::string &text)
{
  _label2.set_text(text);
}


std::string WizardFinishedPage::next_button_caption()
{
#ifdef __APPLE__
  return _("Close");
#elif defined(_WIN32)
  return _("Finish");
#else
  return _("_Close");
#endif
}
