#ifndef _TABLE_FIGURE_SIMPLE_H_
#define _TABLE_FIGURE_SIMPLE_H_

#include "table_figure.h"

namespace wbfig {
class SimpleTable : public Table
{
public:
  SimpleTable(mdc::Layer *layer);

  virtual void set_color(const mdc::Color &color);

  void set_barker_notation(bool flag);

  virtual void set_dependant(bool flag);

  virtual ItemList::iterator begin_columns_sync();
  virtual ItemList::iterator sync_next_column(ItemList::iterator iter,
                                      const std::string &id,
                                      ColumnFlags flags,
                                      const std::string &text);

  virtual void end_columns_sync(ItemList::iterator iter);

  virtual ItemList::iterator begin_indexes_sync() { return ItemList::iterator(); }
  virtual ItemList::iterator sync_next_index(ItemList::iterator iter,
                                      const std::string &id,
                                      const std::string &text)  { return ItemList::iterator(); }
  virtual void end_indexes_sync(ItemList::iterator iter) { }

  
  virtual ItemList::iterator begin_triggers_sync() { return ItemList::iterator(); }
  virtual ItemList::iterator sync_next_trigger(ItemList::iterator iter,
                                      const std::string &id,
                                      const std::string &text) { return ItemList::iterator(); }
  virtual void end_triggers_sync(ItemList::iterator iter) { }

  virtual ItemList *get_columns() { return &_columns; }

protected:
  mdc::Box _column_box;
  ItemList _columns;

  bool _barker;
};
}

#endif /* _TABLE_FIGURE_SIMPLE_H_ */
