#ifndef _WORKBENCH_MODEL_IMAGEFIGURE_IMPL_H_
#define _WORKBENCH_MODEL_IMAGEFIGURE_IMPL_H_

#include "model_figure_impl.h"
#include "grts/structs.workbench.model.h"

#include "image_figure.h"

class WBPUBLICBACKEND_PUBLIC_FUNC workbench_model_ImageFigure::ImplData : public model_Figure::ImplData
{
  typedef model_Figure::ImplData super;

protected:
  wbfig::Image *_figure;
  cairo_surface_t *_thumbnail;
  mdc::Timestamp _last_click;

  virtual bool realize();
  bool shrink_if_needed();

public:
  ImplData(workbench_model_ImageFigure *self);
   
  virtual wbfig::BaseFigure* get_canvas_item() const { return _figure; }
  
  std::string set_filename(const std::string &fn);
  void set_keep_aspect_ratio(bool flag);
   
  virtual void unrealize();

  virtual void render_mini(mdc::CairoCtx *cr);

 private:
   workbench_model_ImageFigure *self() const { return (workbench_model_ImageFigure*)_self; }
}; 

#endif
