#ifndef _WORKBENCH_PHYSICAL_MODEL_IMPL_H_
#define _WORKBENCH_PHYSICAL_MODEL_IMPL_H_

#include "wb_config.h"

#include "model_model_impl.h"
#include "grts/structs.workbench.physical.h"

#include "grt/grt_manager.h"

#include "table_figure.h"
#include "connection_figure.h"

#include "model_connection_impl.h"

  
enum PhysicalRelationshipNotation {
  PRClassicNotation, 
    PRIdef1xNotation,
    PRCrowFoofnotation, // aka Information Engineering
    PRUMLNotation,
    PRFromColumnNotation,
    PRBarkerNotation
};


enum PhysicalFigureNotation {
  PFWorkbenchNotation,
    PFWorkbenchSimpleNotation,
    PFWorkbenchPKOnlyNotation,
    PFIdef1xNotation,
    PFClassicNotation,
    PFBarkerNotation
};


class WBPUBLICBACKEND_PUBLIC_FUNC workbench_physical_Model::ImplData : public model_Model::ImplData
{
  typedef model_Model::ImplData super;

private:
  PhysicalRelationshipNotation _relationship_notation;
  PhysicalFigureNotation _figure_notation;
    
public:
  ImplData(workbench_physical_Model *self);

  void update_relationship_figure(model_Connection::ImplData *cfig, bool imandatory, bool imany, bool fmandatory, bool fmany);
  
  void member_changed_comm(const std::string &name, const grt::ValueRef &value);
  mdc::LineEndType get_line_end_type(bool mand, bool many, bool start);
  std::string get_line_end_caption(bool mand, bool many, bool start);
  wbfig::Table *create_table_figure(mdc::Layer *layer);

  PhysicalRelationshipNotation get_relationship_notation() const { return _relationship_notation; }
  PhysicalFigureNotation get_figure_notation() const { return _figure_notation; }

private:
  workbench_physical_Model *self() const { return (workbench_physical_Model*)_owner; }
};


#endif
