//
//  WBPluginEditorBase.mm
//  MySQLWorkbench
//
//  Created by Alfredo Kojima on 30/Jan/09.
//  Copyright 2009 Sun Microsystems Inc. All rights reserved.
//

#import "WBPluginEditorBase.h"


@implementation WBPluginEditorBase

- (id)identifier
{
  return nil;
}


- (NSString*)title
{
  return nil;
}


- (NSImage*)titleIcon
{
  return nil;
}


- (NSView*)dockableView
{
  return nil;
}


- (void)setMinimumSize:(NSSize)size
{
  mMinumumSize= size;
}


- (void)refresh
{
}


- (NSSize)minimumSize
{
  return mMinumumSize;
}


- (BOOL)matchesIdentifierForClosingEditor:(NSString*)identifier
{
  return NO;
}


- (void)pluginWillClose: (id)sender
{
  // by default, we check if the firstResponder belongs to this plugin and make it
  // resign so that edits are commited
  id first= [[[self dockableView] window] firstResponder];
  id dockableView= [self dockableView];
  NSWindow *window= [[self dockableView] window];
  
  while (first && first != dockableView && first != window)
    first= [first superview];

  if (first != window)
    [first resignFirstResponder];
}

@end
