
#include "stdafx.h"

#include <mforms/form.h>
#include <mforms/mforms.h>

using namespace mforms;

Form::Form(Form *owner, FormFlag flag)
{
  _form_impl= &ControlFactory::get_instance()->_form_impl;
  
  _content= 0;
  _fixed_size= false;
  _form_impl->create(this, owner, flag);
}

void Form::set_title(const std::string &title)
{
  _form_impl->set_title(this, title);
}

bool Form::run_modal(Button *accept, Button *cancel)
{
  return _form_impl->run_modal(this, accept, cancel);
}

void Form::show_modal(Button *accept, Button *cancel)
{
  _form_impl->show_modal(this, accept, cancel);
}

void Form::close()
{
  _form_impl->close(this);
}


void Form::center()
{
  _form_impl->center(this);
}


void Form::set_content(View *view)
{
  _content= view;
  _form_impl->set_content(this, view);
  _content->set_parent(this);
}

void Form::needs_resize()
{
  relayout();
}

void Form::flush_events()
{
  _form_impl->flush_events(this);
}

