#ifndef _WF_TEXTENTRY_H_
#define _WF_TEXTENTRY_H_

#include <mforms/mforms.h>

#include "wf_view.h"

/**
 * Declaration of the Windows wrapper for the mforms TextEntry class.
 */
using namespace System;
using namespace Windows::Forms;

namespace MySQL {
  namespace Forms {

    public ref class TextEntryImpl : public ViewImpl
    {
      static bool create(::mforms::TextEntry *self, bool password);
      static void set_text(::mforms::TextEntry *self, const std::string &text);
      static std::string get_text(::mforms::TextEntry *self);
      static void set_password(::mforms::TextEntry *self, bool flag);
      static void set_max_length(::mforms::TextEntry *self, int length);
      static void change(Object^ sender, EventArgs^ args);
      TextEntryImpl(::mforms::TextEntry *text);
    public:
      static void init(Manager ^mgr)
      {
        ::mforms::ControlFactory *f= ::mforms::ControlFactory::get_instance();

        DEF_CALLBACK2(bool, ::mforms::TextEntry*, bool, mgr, f->_textentry_impl, TextEntryImpl, create);
        DEF_CALLBACK2(void, ::mforms::TextEntry*, const std::string&, mgr, f->_textentry_impl, TextEntryImpl, set_text);
        DEF_CALLBACK1(std::string, ::mforms::TextEntry*, mgr, f->_textentry_impl, TextEntryImpl, get_text);
        DEF_CALLBACK2(void, ::mforms::TextEntry*, int, mgr, f->_textentry_impl, TextEntryImpl, set_max_length);
      }
    };

  };
};

#endif
