#ifndef _GRT_DIFF_H
#define _GRT_DIFF_H

#include "grtpp.h"
#include "grtpp_util.h"

namespace grt
{
class ValueRef;
class BaseListRef;
class DictRef;
//class ObjectRef;
class DiffChange;


class GrtDiff
{
protected:
  int dbgtabs;
  void dbgprint(const ObjectRef &source, const ObjectRef &target)const;

  const Omf* omf;
  virtual DiffChange *on_simple_value(DiffChange *parent, const ValueRef &source, const ValueRef &target, bool caseinsensitive= false);
  virtual DiffChange *on_list(DiffChange *parent, const BaseListRef &source, const BaseListRef &target, const TSlotNormilizerSlot sqlDefinitionCmp);
  virtual DiffChange *on_dict(DiffChange *parent, const DictRef &source, const DictRef &target, const TSlotNormilizerSlot sqlDefinitionCmp);
  virtual DiffChange *on_object(DiffChange *parent, const ObjectRef &source, const ObjectRef &target,const TSlotNormilizerSlot sqlDefinitionCmp);

  virtual DiffChange *on_uncompatible(DiffChange *parent, const ValueRef &source, const ValueRef &target);

  std::string fixDefalutString(std::string str)const;

  DiffChange *on_value(DiffChange *parent, const ValueRef &source, const ValueRef &target, bool caseinsensitive,const TSlotNormilizerSlot sqlDefinitionCmp);
public:
  GrtDiff() : dbgtabs(0),omf(NULL) {};
  DiffChange *diff(const ValueRef &source, const ValueRef &target, const Omf* omf,const TSlotNormilizerSlot sqlDefinitionCmp);
  virtual ~GrtDiff() {}
};

}

#endif
