/*
 *  python_module.h
 *  MySQLWorkbench
 *
 *  Created by Alfredo Kojima on 15/Feb/09.
 *  Copyright 2009 Sun Microsystems Inc. All rights reserved.
 *
 */


#ifndef __PYTHON_GRTMODULE_H__
#define __PYTHON_GRTMODULE_H__

#ifdef __APPLE__
#include <Python/Python.h>
#include <Python/object.h>
#else
#include <Python.h>
#include <object.h>
#endif

#include "grtpp.h"

/** Wraps a GRT module as a Python object
 */
struct PyGRTModuleObject
{
  PyObject_HEAD
  
  grt::Module *module;
};



/** Wraps a GRT module function as a Python object
 */
struct PyGRTFunctionObject
{
  PyObject_HEAD
  
  grt::Module *module;
  const grt::Module::Function *function;
};


#endif
